/**
 * Clase que define las caracteristicas del mundo de simulacion.
 * Implementa constructores y metodos para la interaccion de elementos.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-24
*/

#ifndef MYWORLD_h		// Comprueba si la etiqueta no esta definida
#define MYWORLD_h		// Crea una bandera en tiempo de compilacion

#include "Robot.h"		// Biblioteca de cabecera que permite usar robots

class MyWorld{
	public:
	/* Constructores y metodos */
		MyWorld(): _robot(NULL), _time(0) {}
		void simulate (double delta_t, double endTime);
		void printStateDescription();
		void printState(double t);
		void setRobot(Robot* robot) {_robot = robot;}

	private:
	/* Definicion de variables */
		Robot* _robot;
		double _time;
};

#endif		/* Codigo se incluye en el paquete
	 	 	 * que se envia al compilador hasta aqui */
