/**
 * Implementa los constructores y metodos esenciales que le dan vida al robot
 * (posicion, velocidad, giros en alguna direccion, entre otros).
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-21
*/

#include "MyWorld.h"	/* Libreria de cabecera que define los constructores y metodos a implementar */
#include <iostream>		// Biblioteca para operaciones de entrada y salida
using namespace std;	// Incluye espacio de nombres para palabras reservadas

MyWorld::MyWorld(){
	_robot = NULL;
	_maze = Maze();
	_time = 0;
}

void MyWorld::simulate(double deltaT, double endTime, Maze& route) {
	for (; _time < endTime; _time += deltaT){
		_robot->moveRobot(deltaT);
		route.traceRoute(_robot->getPosition());
		printState(_time);
	}
	/* Metodo que permite la simulacion del tiempo para el robot y el trazado de ruta */
}

void MyWorld::printStateDescription() {
	cout << "Time,\t" + _robot->getDescription() << endl;
	/* Metodo que define la estructura de impresion en consola */
}

void MyWorld::printState(double t) {
	cout << t << ",\t" + _robot->toString() << endl;
	/* Metodo que imprime los valores de tiempo y posicion en consola */
}
