/**
 * Clase que define un vector de un plano cartesiano.
 * Implementa un vector con coordenadas (X,Y) en un plano cartesiano, con las operaciones
 * necesarias para realizar distintas tareas.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-21
*/

#ifndef VECTOR2D_h		// Comprueba si la etiqueta no esta definida
#define VECTOR2D_h		// Crea una bandera en tiempo de compilacion

#include <iostream>		// Biblioteca para las operaciones de entrada y salida
#include <string>		// Biblioteca para trabajar con cadenas de caracteres
#include <sstream>		// Biblioteca para convertir de string a numeros
#include <math.h>		// Biblioteca para el uso de operaciones matematicas
using namespace std;	// Incluye el espacio de nombres para palabras reservadas

class Vector2D {
	public:
	/* Constructores y metodos */
		Vector2D(double x = 0, double y = 0): _x(x), _y(y) {}
		Vector2D getUnitary();
		Vector2D turnLeft();
		Vector2D turnRight();
		string getDescription();
		string toString();
		Vector2D operator+(Vector2D plus);
		Vector2D operator-(Vector2D minus);
		Vector2D operator*(double factor);
		void operator=(Vector2D equal);
		double getX() {return _x;}
		double getY() {return _y;}
		void setTo(double x, double y) {_x = x; _y = y;}

	private:
	/* Definicion de variables */
		double _x, _y;
};

#endif 		/* Codigo se incluye en el paquete
 	 	 	 * que se envia al compilador hasta aqui */
