/**
 * Implementa los constructores y metodos esenciales que le dan vida al robot
 * (posicion, velocidad, giros en alguna direccion, entre otros).
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
*/

#include "MyWorld.h"	/* Libreria de cabecera que define los constructores y metodos a implementar */
#include <iostream>		// Biblioteca para operaciones de entrada y salida
using namespace std;	// Incluye espacio de nombres para palabras reservadas

MyWorld::MyWorld(){
	_robot = NULL;
	_maze = DocumentedMaze();
	_time = 0;
}

void MyWorld::simulate(double deltaT, Maze& route) {
	while(!this->theFinal()){
		_robot->moveRobot(deltaT);
		route.traceRoute(_robot->getPosition());
		printState(_time);
		_time += deltaT;
	}
	/* Metodo que permite la simulacion del tiempo para el robot y el trazado de ruta */
}

void MyWorld::printStateDescription() {
	cout << "Time,\t" + _robot->getDescription() << endl;
	/* Metodo que define la estructura de impresion en consola */
}

void MyWorld::printState(double t) {
	cout << t << ",\t" + _robot->toString() << endl;
	/* Metodo que imprime los valores de tiempo y posicion en consola */
}

bool MyWorld::theFinal(){
	double robot_x = _robot->getPosition().getX();
	double robot_y = _robot->getPosition().getY();
	double exit_x = _maze.getExit().getX();
	double exit_y = _maze.getExit().getY();
	double r = _maze.getExitRadius();

	bool final = robot_x > exit_x - r && robot_x < exit_x + r && robot_y > exit_y - r && robot_y < exit_y + r;
	return final;

	/* Metodo que se encarga de detectar la salida del laberinto para finalizar la simulacion*/
}

