/**
 * Clase que define las caracteristicas del mundo de simulacion.
 * Implementa constructores y metodos para la interaccion de elementos.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
*/

#ifndef MYWORLD_h		// Comprueba si la etiqueta no esta definida
#define MYWORLD_h		// Crea una bandera en tiempo de compilacion

#include "Robot.h"				// Biblioteca de cabecera que permite usar robots
#include "DocumentedMaze.h"		// Biblioteca que permite obtener la info desde el archivo pbm
using namespace std;			// Incluye espacio  de nombres para palabras reservadas

class MyWorld {
	public:
	/* Constructores y metodos */
		MyWorld();
		void simulate(double deltaT, Maze& route);
		void printStateDescription();
		void printState(double t);
		void setRobot(Robot* robot) {_robot = robot;}
		void setMaze(DocumentedMaze maze) {_maze = maze;}
		bool isThere_a_wall(int x, int y) {return _maze.isThere_a_wall(x, y);}
		bool theFinal();

	private:
	/* Definicion de variables */
		Robot* _robot;
		DocumentedMaze _maze;
		double _time;
};

#endif		/* Codigo se incluye en el paquete
	 	 	 * que se envia al compilador hasta aqui */
