/*
 * Clase que define los metodos para implementar un piloto que simule un
 * algoritmo de movimiento que recorra el laberinto pegado a la pared derecha
 * desde una posicion inicial hasta detectar el radio de salida.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
 */

#ifndef PILOT_H_			// Comprueba si la etiqueta no esta definida
#define PILOT_H_			// Crea una bandera en tiempo de compilacion

#include <iostream>				// Biblioteca para las operaciones de entrada y salida
#include "Vector2D.h"			// Biblioteca de cabecera para el uso de vectores
#include "DistanceSensor.h"		// Biblioteca de cabecera para el uso de sensores

using namespace std;			// Incluye espacio de nombres para palabras reservadas

class Robot;		// Declaracion directa del robot para generar espacio en memoria

class Pilot{
	public:
	/* Constructores y metodos */
		Pilot(Robot* robot);
		void setCourse();

	protected:
	/* Declaracion de variables */
	    int _state = 0;
	    Robot* _robot;
	    DistanceSensor *_robotFront, *_robotLeft, *_robotRight;
};

#endif		/* Codigo se incluye en el paquete
	 	 	 * que se envia al compilador hasta aqui */
