/*
 * Clase que extiende de Maze y define los metodos necesarios para obtener los
 * parametros de inicio de simulacion para el laberinto y el robot.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-22
 */

#ifndef DOCUMENTEDMAZE_H_			// Comprueba si la etiqueta no esta definida
#define DOCUMENTEDMAZE_H_			// Crea una bandera en tiempo de compilacion

#include "Maze.h"			// Biblioteca de cabecera para el uso del laberinto
using namespace std;		// Incluye espacio de nombres para palabras reservadas

class DocumentedMaze: public Maze{
	public:
	/* Constructores y metodos */
		DocumentedMaze();
		DocumentedMaze(ifstream& maze);
		void setEntrance(double x, double y);
		void setDirection(double x, double y);
		void setExit(double x, double y);
		void setExitRadius(double radius);
		Vector2D getEntrance();
		Vector2D getDirection();
		Vector2D getExit();
		double getExitRadius();

	private:
	/* Declaracion de variables */
		Vector2D _entrance, _direction, _exit;
		double _exitRadius;
};

#endif 		/* Codigo se incluye en el paquete
 	 	 	 * que se envia al compilador hasta aqui */
