/*
 * Clase que define las caracteristicas del laberinto.
 * Permite rotar un archivo pbm, creando un nuevo archivo de igual extension.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-22
 */

#ifndef MAZE_H_			// Comprueba si la etiqueta no esta definida
#define MAZE_H_			// Crea una bandera en tiempo de compilacion

#include <fstream>			// Biblioteca para las operaciones con archivos
#include "Vector2D.h"		// Biblioteca de cabecera para el uso de vectores
using namespace std;		// Incluye el espacio de nombres para palabras reservadas

class Maze {
	public:
	/* Constructores y metodos */
		Maze(): _array(NULL), _width(0), _height(0) {}
		Maze(ifstream& data);
		Maze(Maze& maze);
		void rotate();
		void write(ofstream& outFile);
		bool** getArray() {return _array;}
		int getWidth() {return _width;}
		int getHeight() {return _height;}
		bool isThere_a_wall(int x, int y);
		void traceRoute(Vector2D position);

	private:
	/* Declaracion de variables */
		bool** _array;
		int _width, _height;
};

#endif 		/* Codigo se incluye en el paquete
 	 	 	 * que se envia al compilador hasta aqui */
