/**
 * Implementa los constructores y metodos esenciales que le dan vida al robot
 * (posicion, velocidad, giros en alguna direccion, entre otros).
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
*/

#include "MyWorld.h"	/* Libreria de cabecera que define los constructores y metodos a implementar */
#include <iostream>		// Biblioteca para operaciones de entrada y salida
using namespace std;	// Incluye espacio de nombres para palabras reservadas

MyWorld::MyWorld(){
	_robot_1 = NULL;
	_robot_2 = NULL;
	_maze = DocumentedMaze();
	_time = 0;
}

void MyWorld::simulate(double deltaT, Maze& route_1, Maze& route_2) {
	while(!this->theFinal()){
		_robot_1->moveRobot_right(deltaT);
		_robot_2->moveRobot_left(deltaT);
		route_1.traceRoute(_robot_1->getPosition());
		route_2.traceRoute(_robot_2->getPosition());
		printState(_time);
		_time += deltaT;
	}
	/* Metodo que permite la simulacion del tiempo para el robot y el trazado de ruta */
}

void MyWorld::printStateDescription(){
	cout << "\t Robot1,\t Robot2" << endl;
	cout << "Time,\t" << _robot_1->getDescription() + ",\t" << _robot_2->getDescription() << endl;
	/* Metodo que define la estructura de impresion en consola */
}

void MyWorld::printState(double t){
	cout << t << ",\t" << _robot_1->toString() + ",\t" << _robot_2->toString() << endl;
	/* Metodo que imprime los valores de tiempo y posicion en consola */
}

bool MyWorld::theFinal(){
	double robot_x_1 = _robot_1->getPosition().getX();
	double robot_y_1 = _robot_1->getPosition().getY();
	double robot_x_2 = _robot_2->getPosition().getX();
	double robot_y_2 = _robot_2->getPosition().getY();
	double exit_x = _maze.getExit().getX();
	double exit_y = _maze.getExit().getY();
	double r = _maze.getExitRadius();

	bool final_1 = robot_x_1 > exit_x - r && robot_x_1 < exit_x + r && robot_y_1 > exit_y - r && robot_y_1 < exit_y + r;
	bool final_2 = robot_x_2 > exit_x - r && robot_x_2 < exit_x + r && robot_y_2 > exit_y - r && robot_y_2 < exit_y + r;
	return final_1 || final_2;
	/* Metodo que se encarga de detectar la salida del laberinto para finalizar la simulacion*/
}

